import { AgentEnvironment, IAgentUpdate, IStateUpdate } from 'enviro-rx';
import { IArtificialAState, IArtificialEState, IArtificialOptions, IGenomeOptions, ISpecimen, ReactiveCollection } from '../index';
export declare abstract class ArtificialSelection<Gen extends IGenomeOptions, Pheno> extends AgentEnvironment<IArtificialAState, IArtificialEState<Gen, Pheno>> {
    options: IArtificialOptions;
    genOptions: Gen;
    specimens: ReactiveCollection<ISpecimen<Gen, Pheno>>;
    parents: ReactiveCollection<ISpecimen<Gen, Pheno>>;
    constructor(options: IArtificialOptions, genOptions: Gen);
    interact(interaction: IAgentUpdate<IArtificialAState>): Promise<IStateUpdate<IArtificialEState<Gen, Pheno>>>;
    readonly defaultState: IArtificialEState<Gen, Pheno>;
    readonly initialState: IStateUpdate<IArtificialEState<Gen, Pheno>>;
    abstract createSpecimen(options: Gen): ISpecimen<Gen, Pheno>;
    abstract reproduceSpecimen(parents: Array<ISpecimen<Gen, Pheno>>): ISpecimen<Gen, Pheno>;
    kill(indices?: number[]): void;
    keep(indices?: number[]): void;
    randomize(indices?: number[]): void;
    private fillSpecimens(specs?, n?);
    private fillParents(parents?, n?);
    private reproduceSpecimens(specs, parents, n?);
    private syncSpecimens();
    private ageSpecimens(specs);
    private killSpecimens(specs, parents, kill);
    private keepSpecimens(specs, parents, keep);
    private randomizeSpecimens(specs, parents, randomize);
}
